> For the complete documentation index, see [llms.txt](https://docs.apryse.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.apryse.com/ios/ui-customization/setup.md).

# Tools framework setup

Learn how to set up the Tools framework for your project. Add PTToolManager to PTPDFViewCtrl to enable annotation selection, form filling, and more. Customize ToolManager properties for advanced featu

*This guide demonstrates how to set up the Tools framework. To begin using the Tools framework, you must have first* [*added it to your project*](/ios/get-started/get-started.md) *and* [*set up the PDFNet library*](/ios/guides/getting-started/showing-a-pdf.md)*.*

## Adding a tool manager

The `Tools.framework` can be used in your project by simply adding a [`PTToolManager`](https://sdk.apryse.com/api/ios/Classes/PTToolManager.html) to an existing [`PTPDFViewCtrl`](https://sdk.apryse.com/api/ios/Classes/PTPDFViewCtrl.html) as its tool delegate:

{% tabs %}
{% tab title="Swift" %}
{% code lineNumbers="true" %}

```swift
import Tools

// Create the tool manager (used to implement text selection, annotation editing, etc.)
self.toolManager = ToolManager(pdfViewCtrl: self.pdfViewCtrl)

// Register the tool manager to receive events.
self.pdfViewCtrl.toolDelegate = self.toolManager;

// Set the initial tool.
self.toolManager.changeTool(PanTool.self)
```

{% endcode %}
{% endtab %}

{% tab title="Obj-C" %}
{% code lineNumbers="true" %}

```objc
#import <Tools/Tools.h>

// Create a new tool manager using the designated initializer.
self.toolManager = [[ToolManager alloc] initWithPDFViewCtrl:self.pdfViewCtrl];
    
// Register the tool manager to receive events.
self.pdfViewCtrl.toolDelegate = self.toolManager;
    
// Set the initial tool.
[self.toolManager changeTool:[PanTool class]];
```

{% endcode %}
{% endtab %}
{% endtabs %}

{% tabs %}
{% tab title="C#" %}
{% code lineNumbers="true" %}

```csharp
using pdftron.PDF.Tools;

// Create the tool manager (used to implement text selection, annotation editing, etc.)
mToolManager = new PTToolManager(mPdfViewCtrl);

// Register the tool manager to receive events.
mPdfViewCtrl.ToolManager = mToolManager;

// Set the initial tool.
self.toolManager.changeTool(PanTool.self)
```

{% endcode %}
{% endtab %}
{% endtabs %}

You can now tap to select and edit annotations, fill forms, long press to select text, and long press empty areas of the document to create annotations.

## Configuration

A `ToolManager` instance can be configured by setting its properties.

The following code shows how to disable text selection and editing of ink (free hand) annotations:

{% tabs %}
{% tab title="Swift" %}
{% code lineNumbers="true" %}

```swift
// Disable editing of ink annotations.
toolManager.inkAnnotationPermission.canEdit = false

// Disable text selection.
toolManager.textSelectionEnabled = false
```

{% endcode %}
{% endtab %}

{% tab title="Obj-C" %}
{% code lineNumbers="true" %}

```objc
// Disable editing of ink annotations.
toolManager.inkAnnotationPermission.canEdit = NO;

// Disable text selection.
toolManager.textSelectionEnabled = NO;
```

{% endcode %}
{% endtab %}
{% endtabs %}

{% tabs %}
{% tab title="C#" %}
{% code lineNumbers="true" %}

```csharp
// Disable editing of ink annotations.
mToolManager.InkAnnotationOptions.CanEdit = false;

// Disable text selection.
mToolManager.TextSelectionEnabled = false;
```

{% endcode %}
{% endtab %}
{% endtabs %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.apryse.com/ios/ui-customization/setup.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
